unit PaletteFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Menus, Dialogs, StdCtrls, ExtCtrls, ComCtrls, TypInfo, ImgList,
  ActnList, ToolWin, DesignIntf, DockForm, IniFiles, ToolsApi,
  ComponentDesigner, Buttons, Contnrs, ActnPopup, DockToolForm, DeskStrs;

const
  AM_LOADCOMPONENTS = WM_USER + 1;

type
  TComponentInfo = class
  public
    ToolName: string;
    TabIndex: Integer;
    ToolIndex: Integer;
    ComponentClass: TComponentClass;
    ImageIndex: Integer;
    UnitName: string;
    PackageName: string;
    constructor Create(const AToolName: string; ATabIndex, AToolIndex: Integer;
      AComponentClass: TComponentClass);
  end;

  TCompInfoList = class(TObjectList)
  private
    function Get(Index: Integer): TComponentInfo;
    procedure Put(Index: Integer; const Value: TComponentInfo);
  protected
  public
    function Add(AInfo: TComponentInfo): Integer;
    property Items[Index: Integer]: TComponentInfo read Get write Put; default;
  end;

  TFloatingPaletteForm = class(TDockableToolbarForm, IOTANotifier, IOTAIDENotifier, IOTAIDENotifier50, IDesignNotification)
    Tree: TTreeView;
    Splitter: TSplitter;
    ComponentImages: TImageList;
    TreeImages: TImageList;
    ActionsForIDE: TActionList;
    actFloatingPalette: TAction;
    Actions: TActionList;
    ActionImages: TImageList;
    actRefresh: TAction;
    ToolButton1: TToolButton;
    actShowList: TAction;
    ToolButton2: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    actConfigurePalette: TAction;
    StatusBar: TStatusBar;
    actStatusbarVisible: TAction;
    actSortedTabNames: TAction;
    actSortComponents: TAction;
    ToolButton3: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    actCreateComponent: TAction;
    actUseComponentImages: TAction;
    EmptyImages: TImageList;
    actVerticalArrangement: TAction;
    ToolButton10: TToolButton;
    Panel: TPanel;
    ComponentImagesSmall: TImageList;
    EmptyImagesSmall: TImageList;
    actRollUp: TAction;
    actAutoRollup: TAction;
    actSelector: TAction;
    tbtnSelector: TToolButton;
    Bevel1: TBevel;
    pnlStatusBar: TPanel;
    actCustomize: TAction;
    ToolButton8: TToolButton;
    actShowTree: TAction;
    ToolButton9: TToolButton;
    ToolButton12: TToolButton;
    Customize1: TMenuItem;
    ConfigurePalette2: TMenuItem;
    UseComponentImages1: TMenuItem;
    VerticalArrangement1: TMenuItem;
    AutoRollUp1: TMenuItem;
    N1: TMenuItem;
    Statusbar1: TMenuItem;
    extLabels1: TMenuItem;
    N2: TMenuItem;
    AlwaysOnTop1: TMenuItem;
    Dockable1: TMenuItem;
    pnlTree: TPanel;
    pnlList: TPanel;
    TabList: TListView;
    N3: TMenuItem;
    SortTabNames1: TMenuItem;
    SortComponents1: TMenuItem;
    Comps: TListView;
    Action1: TAction;
    Action2: TAction;
    Action3: TAction;
    Action4: TAction;
    pumList: TPopupActionBar;
    Action11: TMenuItem;
    Action21: TMenuItem;
    Action31: TMenuItem;
    Action41: TMenuItem;
    actRollUpOnCreation: TAction;
    Rolluponcomponentcreation1: TMenuItem;
    pnlSearch: TPanel;
    Label1: TLabel;
    cmbSearch: TComboBox;
    btnGo: TSpeedButton;
    Bevel2: TBevel;
    actSearch: TAction;
    ToolButton11: TToolButton;
    N4: TMenuItem;
    Search1: TMenuItem;
    procedure TreeChange(Sender: TObject; Node: TTreeNode);
    procedure actFloatingPaletteExecute(Sender: TObject);
    procedure actRefreshExecute(Sender: TObject);
    procedure actShowListExecute(Sender: TObject);
    procedure actShowListUpdate(Sender: TObject);
    procedure actConfigurePaletteExecute(Sender: TObject);
    procedure actSortedTabNamesExecute(Sender: TObject);
    procedure actSortComponentsExecute(Sender: TObject);
    procedure actCreateComponentExecute(Sender: TObject);
    procedure actCreateComponentUpdate(Sender: TObject);
    procedure TreeGetImageIndex(Sender: TObject; Node: TTreeNode);
    procedure actUseComponentImagesExecute(Sender: TObject);
    procedure TreeEnter(Sender: TObject);
    procedure actVerticalArrangementExecute(Sender: TObject);
    procedure TreeMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormConstrainedResize(Sender: TObject; var MinWidth,
      MinHeight, MaxWidth, MaxHeight: Integer);
    procedure actRollUpExecute(Sender: TObject);
    procedure actRollUpHint(var HintStr: String; var CanShow: Boolean);
    procedure actAutoRollupExecute(Sender: TObject);
    procedure actSelectorExecute(Sender: TObject);
    procedure actSelectorUpdate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure actVerticalArrangementUpdate(Sender: TObject);
    procedure actCustomizeExecute(Sender: TObject);
    procedure actShowTreeExecute(Sender: TObject);
    procedure actShowTreeUpdate(Sender: TObject);
    procedure actStatusbarVisibleExecute(Sender: TObject);
    procedure actStatusbarVisibleUpdate(Sender: TObject);
    procedure TreeAdvancedCustomDrawItem(Sender: TCustomTreeView;
      Node: TTreeNode; State: TCustomDrawState; Stage: TCustomDrawStage;
      var PaintImages, DefaultDraw: Boolean);
    procedure TabListSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure TabListEnter(Sender: TObject);
    procedure SplitterPaint(Sender: TObject);
    procedure CompsData(Sender: TObject; Item: TListItem);
    procedure CompsAdvancedCustomDrawItem(Sender: TCustomListView;
      Item: TListItem; State: TCustomDrawState; Stage: TCustomDrawStage;
      var DefaultDraw: Boolean);
    procedure CompsSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure CompsEnter(Sender: TObject);
    procedure CompsInfoTip(Sender: TObject; Item: TListItem;
      var InfoTip: String);
    procedure Action1Execute(Sender: TObject);
    procedure Action1Update(Sender: TObject);
    procedure actRollUpOnCreationExecute(Sender: TObject);
    procedure btnGoClick(Sender: TObject);
    procedure cmbSearchKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure actSearchUpdate(Sender: TObject);
    procedure actSearchExecute(Sender: TObject);
    procedure cmbSearchDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
  private
    FNotifier: Integer;
    FAppBuilder: TForm;
    FPaletteTab: TTabControl;
    FPalette: TCustomControl;
    FTabs: TStringList;
    FCompInfoList: TCompInfoList;
    FHiddenTabs: TStringList;
    FDisabledTabs: TStringList;
    FLoading: Boolean;
    FLoadingState: Boolean;
    FSaveHeight: Integer;
    FMaxHeight: Integer;
    FNeedsUpdate: Boolean;
    FOldListWndProc: TWndMethod;
    FCompilingPackage: Boolean;
    FComps: TStringList;
    procedure LoadComponents;
    procedure PostLoadComponents;
    procedure UpdateStatusBar;
    procedure UpdateList;
    function GetCompIndex(Info: TComponentInfo): Integer;
    procedure ArrangeControls;
    function GetActiveComponent: TComponentInfo;
    procedure RollDown;
    procedure RollUp;
    function IsRolledDown: Boolean;
    procedure LoadSettings;
    procedure SaveSettings;

    function GetTreeState: string;
    procedure SetTreeState(const Value: string);

    procedure AMLoadComponents(var M: TMessage); message AM_LOADCOMPONENTS;
    procedure WMNCHitTest(var M: TWMNCHitTest); message WM_NCHITTEST;
    procedure WMNCLButtonDblClick(var M: TWMNCLButtonDblClk); message WM_NCLBUTTONDBLCLK;

    procedure ListWndProc(var Message: TMessage);
  protected
    // IOTANotifier
    procedure AfterSave;
    procedure BeforeSave;
    procedure Destroyed;
    procedure Modified;

    // IOTAIDENotifier
    procedure FileNotification(NotifyCode: TOTAFileNotification;
      const FileName: string; var Cancel: Boolean);

    procedure BeforeCompile(const Project: IOTAProject; var Cancel: Boolean); overload;
    procedure AfterCompile(Succeeded: Boolean); overload;

    procedure BeforeCompile(const Project: IOTAProject; IsCodeInsight: Boolean;
      var Cancel: Boolean); overload;
    { Same as AfterCompile on IOTAIDENotifier except indicates if the compiler
      was invoked due to a CodeInsight compile }
    procedure AfterCompile(Succeeded: Boolean; IsCodeInsight: Boolean); overload;

    // IDesignNotification
    procedure ItemDeleted(const ADesigner: IDesigner; AItem: TPersistent);
    procedure ItemInserted(const ADesigner: IDesigner; AItem: TPersistent);
    procedure ItemsModified(const ADesigner: IDesigner);
    procedure SelectionChanged(const ADesigner: IDesigner;
      const ASelection: IDesignerSelections);
    procedure DesignerOpened(const ADesigner: IDesigner; AResurrecting: Boolean);
    procedure DesignerClosed(const ADesigner: IDesigner; AGoingDormant: Boolean);
  protected
    procedure DoMainFormShown; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Dock(NewDockSite: TWinControl; ARect: TRect); override;

    procedure SaveWindowState(Desktop: TMemIniFile; IsProject: Boolean); override;
    procedure LoadWindowState(Desktop: TMemIniFile); override;

    property PaletteTabs: TStringList read FTabs;
    property HiddenTabs: TStringList read FHiddenTabs;
    property DisabledTabs: TStringList read FDisabledTabs;

    procedure RefreshUI;

    property SaveStateNecessary;
  end;

var
  FloatingPaletteForm: TFloatingPaletteForm;

procedure Register;

implementation

uses CommCtrl, Registry, DeskForm, DeskUtil, VisibleTabsDlg, Types,
  ListActns;

{$R *.dfm}

resourcestring
  sRollDown = 'Roll Down';
  sRollUp = 'Roll Up';

procedure Register;
begin
  TFloatingPaletteForm.Create(TForm(Application.FindComponent('AppBuilder')));
end;

function SelectTool(tab: Integer = -1; toolindex: integer = -1): string;
var
  AppBuilder: TForm;
  PaletteTab: TTabControl;
  Palette: TCustomControl;
  ToolSelector: TSpeedButton;
begin
  Result := '';
  AppBuilder := TForm(Application.FindComponent('AppBuilder'));
  PaletteTab := TTabControl(AppBuilder.FindComponent('TabControl'));
  Palette := TCustomControl(AppBuilder.FindComponent('Palette'));
  if tab = -1 then
  begin
    ToolSelector := TSpeedButton(GetObjectProp(Palette, GetPropInfo(Palette.ClassInfo, 'Selector')));
    ToolSelector.Click;
  end
  else
  begin
    PaletteTab.TabIndex := tab;
    PaletteTab.OnChange(PaletteTab);
    Result := '';
    if toolindex <> -1 then
    begin
      SetOrdProp(Palette, 'SelectedIndex', ToolIndex);
      Result := GetStrProp(Palette, 'SelectedToolName');
    end;
  end;
end;

function ClassNameNoT(AClassName: string): string;
begin
  Result := AClassName;
  if Result[1] = 'T' then Delete(Result, 1, 1);
  if CompareText('Field', Copy(Result, Length(Result) - 4, 5)) = 0 then { do not localize }
    Delete(Result, Length(Result) - 4, 5);
end;

{ TComponentInfo }

constructor TComponentInfo.Create(const AToolName: string; ATabIndex,
  AToolIndex: Integer; AComponentClass: TComponentClass);
begin
  ToolName := AToolName;
  TabIndex := ATabIndex;
  ToolIndex := AToolIndex;
  ComponentClass := AComponentClass;
  ImageIndex := -1;
  if Assigned(ComponentClass) then
  begin
    UnitName := GetTypeData(PTypeInfo(ComponentClass.ClassInfo)).UnitName;
    PackageName :=  ChangeFileExt(ExtractFileName(GetModuleName(FindClassHInstance(ComponentClass))), '');
  end;
end;

{ TCompInfoList }

function TCompInfoList.Add(AInfo: TComponentInfo): Integer;
begin
  Result := inherited Add(AInfo);
end;

function TCompInfoList.Get(Index: Integer): TComponentInfo;
begin
  Result := TComponentInfo(inherited Items[Index]);
end;

procedure TCompInfoList.Put(Index: Integer; const Value: TComponentInfo);
begin
  inherited Items[Index] := Value;
end;

const
  sPaletteSection = 'ComponentPalette';
  sInstanceName = 'FloatingPaletteForm';

{ TFloatingPaletteForm }

constructor TFloatingPaletteForm.Create(AOwner: TComponent);
var
  IDEActions: TCustomActionList;
  I: Integer;
  Menu: TMainMenu;
  Item, MenuItem, MyItem: TMenuItem;
  Action: TCustomAction;
  B: TBitmap;
begin
  DeskSection := sPaletteSection;
  inherited;
  FloatingPaletteForm := Self;

  FTabs := TStringList.Create;
  FHiddenTabs := TStringList.Create;
  FHiddenTabs.Sorted := True;
  FDisabledTabs := TStringList.Create;
  FDisabledTabs.Sorted := True;
  Tree.Align := alClient;
  FCompInfoList := TCompInfoList.Create(True);
  FComps := TStringList.Create;

  FOldListWndProc := Comps.WindowProc;
  Comps.WindowProc := ListWndProc;

  FAppBuilder := TForm(Application.FindComponent('AppBuilder'));
  FPaletteTab := TTabControl(FAppBuilder.FindComponent('TabControl'));
  FPalette := TCustomControl(FAppBuilder.FindComponent('Palette'));

  IDEActions := (BorlandIDEServices as INTAServices).GetActionList;
  for I := ActionsForIDE.ActionCount - 1 downto 0 do
  begin
    Action := TCustomAction(ActionsForIDE[I]);
    if Action.ImageIndex >= 0 then
    begin
      B := TBitmap.Create;
      try
        B.Width := ActionsForIDE.Images.Width;
        B.Height := ActionsForIDE.Images.Height;
        ActionsForIDE.Images.GetBitmap(Action.ImageIndex, B);
        Action.ImageIndex := (BorlandIDEServices as INTAServices).AddMasked(B, B.TransparentColor, Action.Name);
      finally
        B.Free;
      end;
    end;
    Action.ActionList := IDEActions;
  end;

  Menu := (BorlandIDEServices as INTAServices).GetMainMenu;

  MenuItem := Menu.Items.Find('View');
  Assert(Assigned(MenuItem));
  Item := TMenuItem(Menu.Owner.FindComponent('ViewObjTreeViewItem'));

  MyItem := TMenuItem.Create(Self);
  MyItem.Action := actFloatingPalette;
  MenuItem.Insert(Item.MenuIndex, MyItem);

  FNotifier := (BorlandIDEServices as IOTAServices).AddNotifier(Self);
  RegisterDesignNotification(Self);

  LoadSettings;
  LoadComponents;
end;

destructor TFloatingPaletteForm.Destroy;
begin
  SaveSettings;
  UnregisterDesignNotification(Self);
  (BorlandIDEServices as IOTAServices).RemoveNotifier(FNotifier);
  Comps.Clear;
  FreeAndNil(FCompInfoList);
  FreeAndNil(FHiddenTabs);
  FreeAndNil(FDisabledTabs);
  FreeAndNil(FTabs);
  FreeAndNil(FComps);
  inherited;
end;

procedure TFloatingPaletteForm.AfterSave;
begin

end;

procedure TFloatingPaletteForm.BeforeSave;
begin

end;

procedure TFloatingPaletteForm.Destroyed;
begin

end;

procedure TFloatingPaletteForm.Modified;
begin

end;

procedure TFloatingPaletteForm.FileNotification(NotifyCode: TOTAFileNotification;
  const FileName: string; var Cancel: Boolean);
begin
  case NotifyCode of
    ofnPackageInstalled, ofnPackageUninstalled:
      PostLoadComponents;
  end;
end;

procedure TFloatingPaletteForm.BeforeCompile(const Project: IOTAProject;
  var Cancel: Boolean);
begin
end;


procedure TFloatingPaletteForm.AfterCompile(Succeeded: Boolean);
begin
end;

procedure TFloatingPaletteForm.BeforeCompile(const Project: IOTAProject; IsCodeInsight: Boolean;
  var Cancel: Boolean);
var
  I: Integer;
  Name: string;
begin
  if IsCodeInsight then Exit;
  FCompilingPackage := False;
  if not SameText(ExtractFileExt(Project.FileName), '.dpk') then Exit;
  Name :=  ChangeFileExt(ExtractFileName(Project.FileName), '');
  with BorlandIDEServices as IOTAPackageServices do
  begin
    for I := 0 to PackageCount - 1 do
      if SameText(PackageNames[I], Name) then
      begin
        FCompilingPackage := True;
        Break;
      end;
  end;
  if FCompilingPackage then LoadComponents;
end;

procedure TFloatingPaletteForm.AfterCompile(Succeeded: Boolean; IsCodeInsight: Boolean);
begin
  if IsCodeInsight then Exit;
  if FCompilingPackage then PostLoadComponents;
  FCompilingPackage := False;
end;

procedure TFloatingPaletteForm.ItemDeleted(const ADesigner: IDesigner; AItem: TPersistent);
begin
end;

procedure TFloatingPaletteForm.ItemInserted(const ADesigner: IDesigner; AItem: TPersistent);
begin
  if (GetStrProp(FPalette, 'SelectedToolName') <> '') and
    actRollUpOnCreation.Checked then RollUp;
  if Assigned(Tree.Selected) and Assigned(Tree.Selected.Data) then
    Tree.Selected := nil;
  Comps.Selected := nil;
end;

procedure TFloatingPaletteForm.ItemsModified(const ADesigner: IDesigner);
begin
end;

procedure TFloatingPaletteForm.SelectionChanged(const ADesigner: IDesigner;
  const ASelection: IDesignerSelections);
begin
end;

procedure TFloatingPaletteForm.DesignerOpened(const ADesigner: IDesigner; AResurrecting: Boolean);
begin
end;

procedure TFloatingPaletteForm.DesignerClosed(const ADesigner: IDesigner; AGoingDormant: Boolean);
begin
end;

procedure TFloatingPaletteForm.LoadWindowState(Desktop: TMemIniFile);
var
  State: string;
begin
  FLoadingState := True;
  try
    inherited;
    pnlStatusbar.Visible := Desktop.ReadBool(DeskSection, 'Statusbar', True);

    State := Desktop.ReadString(DeskSection, 'TreeState', '');
    if State <> '' then SetTreeState(State);

    State := Desktop.ReadString(DeskSection, 'HiddenTabs', '');
    if State <> FHiddenTabs.CommaText then
    begin
      FHiddenTabs.CommaText := State;
      RefreshUI;
    end;
    if Desktop.ReadBool(DeskSection, 'RolledDown', True) then RollDown else RollUp;

  if actVerticalArrangement.Checked then
    TabList.Height := Desktop.ReadInteger(DeskSection, 'ListExtent', TabList.Height)
  else
    TabList.Width := Desktop.ReadInteger(DeskSection, 'ListExtent', TabList.Width)
  finally
    FLoadingState := False;
  end;
end;

procedure TFloatingPaletteForm.SaveWindowState(Desktop: TMemIniFile;
  IsProject: Boolean);
var
  WindowPlacement: TWindowPlacement;
begin
  { Skip default desktop save if we don't have a Desktop. }
  if Desktop = nil then Exit;

  // inherited; - do it manually to adjust for rolled-up state.

  // TDesktopForm
  SaveStateNecessary := True;//IsDocked or (Visible and not IsDocked);
  if SaveStateNecessary then
    with Desktop do
    begin
      WriteBool(DeskSection, ivCreate, True);
      WriteBool(DeskSection, ivVisible, Visible);
      WriteInteger(DeskSection, ivState, Ord(WindowState));
      WindowPlacement.length := SizeOf(WindowPlacement);
      GetWindowPlacement(Handle, @WindowPlacement);
      with WindowPlacement.rcNormalPosition do
      begin
        if not IsRolledDown then
          Bottom := Top + FSaveHeight;
        WriteInteger(DeskSection, ivLeft, left);
        WriteInteger(DeskSection, ivTop, top);
        WriteInteger(DeskSection, ivWidth, right - left);
        WriteInteger(DeskSection, ivHeight, bottom - top);
        WriteInteger(DeskSection, ivMaxLeft, WindowPlacement.ptMaxPosition.x);
        WriteInteger(DeskSection, ivMaxTop, WindowPlacement.ptMaxPosition.y);
        if WindowState = wsMaximized then
        begin
          WriteInteger(DeskSection, ivMaxWidth, Width);
          WriteInteger(DeskSection, ivMaxHeight, Height);
        end;
      end;
      WriteInteger(DeskSection, ivClientWidth, ClientWidth);
      if IsRolledDown then WriteInteger(DeskSection, ivClientHeight, ClientHeight);
    end;

  // TDockableForm
  if SaveStateNecessary and (Desktop <> nil) then
  begin
    Desktop.WriteInteger(DeskSection, ivTBDockHeight, TBDockHeight);
    Desktop.WriteInteger(DeskSection, ivLRDockWidth, LRDockWidth);
    Desktop.WriteBool(DeskSection, ivDockable, Dockable);
  end;

  Desktop.WriteBool(DeskSection, 'Statusbar', pnlStatusBar.Visible);
  Desktop.WriteString(DeskSection, 'TreeState', GetTreeState);
  if IsProject then
    Desktop.WriteString(DeskSection, 'HiddenTabs', FHiddenTabs.CommaText);
  Desktop.WriteBool(DeskSection, 'RolledDown', IsRolledDown);
  if actVerticalArrangement.Checked then
    Desktop.WriteInteger(DeskSection, 'ListExtent', TabList.Height)
  else
    Desktop.WriteInteger(DeskSection, 'ListExtent', TabList.Width);
end;

procedure TFloatingPaletteForm.RefreshUI;

  procedure UpdateTree;
  var
    I, J: Integer;
    Node: TTreeNode;
    State: string;
  begin
    Tree.Items.BeginUpdate;
    try
      State := GetTreeState;

      Tree.Selected := nil;
      Comps.Items.Clear;
      Tree.Items.Clear;

      for I := 0 to FTabs.Count - 1 do
      begin
        if (FHiddenTabs.IndexOf(FTabs[I]) >= 0) or (FDisabledTabs.IndexOf(FTabs[I]) >= 0) then
          Continue;
        Node := Tree.Items.Add(nil, FTabs[I]);
        for J := 0 to FCompInfoList.Count - 1 do
          if FCompInfoList[J].TabIndex = I then
            Tree.Items.AddChildObject(Node, ClassNameNoT(FCompInfoList[J].ToolName), FCompInfoList[J]);
        if actSortComponents.Checked then Node.AlphaSort(False);
      end;
      if actSortedTabNames.Checked then Tree.Items.AlphaSort(False);
      SetTreeState(State);
    finally
      Tree.Items.EndUpdate;
      UpdateList;
    end;
  end;

  procedure UpdateTabList;
  var
    I: Integer;
    S: string;
  begin
    if Assigned(TabList.Selected) then
      S := TabList.Selected.Caption
    else
      S := '';
    TabList.Items.BeginUpdate;
    try
      TabList.Selected := nil;
      TabList.Items.Clear;
      for I := 0 to FTabs.Count - 1 do
      begin
        if (FHiddenTabs.IndexOf(FTabs[I]) >= 0) or (FDisabledTabs.IndexOf(FTabs[I]) >= 0)  then
          Continue;
        with TabList.Items.Add do
        begin
          Caption := FTabs[I];
          Data := TObject(I);
          if SameText(FTabs[I], S) then Selected := True;
          ImageIndex := 0;
        end;
      end;
      if actSortedTabNames.Checked then TabList.AlphaSort;
    finally
      TabList.Items.EndUpdate;
      UpdateList;
    end;
  end;

  procedure UpdateSearch;
  var
    I: Integer;
    TabName: string;
    Info: TComponentInfo;
  begin
    cmbSearch.Items.Clear;
    for I := 0 to FCompInfoList.Count - 1 do
    begin
      Info := FCompInfoList[I];
      TabName := FTabs[Info.TabIndex];
      if (FHiddenTabs.IndexOf(TabName) < 0) and (FDisabledTabs.IndexOf(TabName) < 0) then
        cmbSearch.Items.AddObject(ClassNameNoT(Info.ToolName), Info);
    end;
  end;

begin
  UpdateSearch;
  UpdateTree;
  UpdateTabList;
end;

procedure TFloatingPaletteForm.LoadComponents;
var
  I, J: Integer;
  Palette: TCustomControl;
  PalToolCount: Integer;
  OldPaletteIndex, OldToolIndex: integer;
  SelectedToolName: string;
  Info: TComponentInfo;
  State: string;
begin
  Tree.Items.BeginUpdate;
  try
    if Application.Terminated then
    begin
      Tree.Selected := nil;
      TabList.Selected := nil;
      TabList.Clear;
      Comps.Clear;
      Tree.Items.Clear;
      FTabs.Clear;
      FComps.Clear;
      FCompInfoList.Clear;
      Exit;
    end;
    Palette := TCustomControl(FAppBuilder.FindComponent('Palette'));
    OldPaletteIndex := FPaletteTab.TabIndex;
    OldToolIndex := GetOrdProp(Palette, 'SelectedIndex');
    FLoading := True;
    State := GetTreeState;
    SendMessage(FPaletteTab.Handle, WM_SETREDRAW, 0, 0);
    SendMessage(Palette.Handle, WM_SETREDRAW, 0, 0);
    FPaletteTab.Visible := False;
    try
      Comps.Clear;
      FTabs.Clear;
      FComps.Clear;
      FCompInfoList.Clear;
      ComponentImages.Assign(EmptyImages);
      ComponentImagesSmall.Assign(EmptyImagesSmall);

      with FPaletteTab do
        for I := 0 to Tabs.Count - 1 do
        begin
          FPaletteTab.TabIndex := I;
          FPaletteTab.OnChange(FPaletteTab);
          FTabs.Add(FPaletteTab.Tabs[I]);
          PalToolCount := GetOrdProp(Palette, 'PalToolCount');
          for J := 0 to PalToolCount - 1 do
          begin
            SetOrdProp(Palette, 'SelectedIndex', J);
            SelectedToolName := GetStrProp(Palette, 'SelectedToolName');
            Info := TComponentInfo.Create(SelectedToolName, I, J, TComponentClass(GetClass(SelectedToolName)));
            FCompInfoList.Add(Info);
          end;
        end;
    finally
      FPaletteTab.TabIndex := OldPaletteIndex;
      FPaletteTab.OnChange(FPaletteTab);
      SendMessage(FPaletteTab.Handle, WM_SETREDRAW, 1, 0);
      SendMessage(Palette.Handle, WM_SETREDRAW, 1, 0);

      SetOrdProp(Palette, 'SelectedIndex', OldToolIndex);
      FPaletteTab.Visible := True;

      FLoading := False;
      RefreshUI;
      SetTreeState(State);
      FNeedsUpdate := False;
    end;
  finally
    Tree.Items.EndUpdate;
  end;
end;

procedure TFloatingPaletteForm.PostLoadComponents;
begin
  if not FNeedsUpdate then
  begin
    FNeedsUpdate := True;
    PostMessage(Handle, AM_LOADCOMPONENTS, 0, 0);
  end;
end;

function TFloatingPaletteForm.GetActiveComponent: TComponentInfo;
begin
  Result := nil;
  if (Screen.ActiveControl = Comps) and Assigned(Comps.Selected) then
    Result := TComponentInfo(FComps.Objects[Comps.Selected.Index])
  else if Assigned(Tree.Selected) then
    Result := TComponentInfo(Tree.Selected.Data);
end;

procedure TFloatingPaletteForm.UpdateStatusBar;
var
  Info: TComponentInfo;
begin
  StatusBar.Panels[1].Text := '';
  StatusBar.Panels[3].Text := '';
  StatusBar.Panels[5].Text := '';
  Info := GetActiveComponent;
  if Assigned(Info) then
    with Info do
    begin
      StatusBar.SimplePanel := False;
      StatusBar.Panels[1].Text := ToolName;
      if Assigned(ComponentClass) then
      begin
        StatusBar.Panels[3].Text := UnitName;
        StatusBar.Panels[5].Text := PackageName;
      end;
    end
  else
  begin
    StatusBar.SimplePanel := True;
    if pnlTree.Visible then
      if Assigned(Tree.Selected) then
        StatusBar.SimpleText := Tree.Selected.Text
      else
        StatusBar.SimpleText := ''
    else
      if Assigned(TabList.Selected) then
        StatusBar.SimpleText := TabList.Selected.Caption
      else
        StatusBar.SimpleText := '';
  end;
end;

function TFloatingPaletteForm.GetCompIndex(Info: TComponentInfo): Integer;
var
  AClass: TComponentClass;
  PalItem: IPaletteItem;
  Bmp, Bmp1: TBitmap;
begin
  if Info.ToolName ='Frames' then
  begin
    Result := 1;
    Exit;
  end;
  AClass := TComponentInfo(Info).ComponentClass;
  if Assigned(AClass) and (Info.ImageIndex = -1) then
  begin
    PalItem := ComponentDesigner.ActiveDesigner.Environment.GetPaletteItem(TComponentClass(AClass));
    Bmp1 := nil;
    Bmp := TBitmap.Create;
    try
      Bmp.Width := ComponentImages.Width;
      Bmp.Height := ComponentImages.Height;
      Bmp.Canvas.Brush.Color := clOlive;
      Bmp.Canvas.FillRect(Rect(0, 0, Bmp.Width, Bmp.Height));
      Bmp1 := TBitmap.Create;
      Bmp1.Width := ComponentImagesSmall.Width;
      Bmp1.Height := ComponentImagesSmall.Height;
      Bmp1.Canvas.Brush.Color := clOlive;
      Bmp1.Canvas.FillRect(Rect(0, 0, Bmp1.Width, Bmp1.Height));
      (PalItem as IPalettePaint).Paint(Bmp.Canvas, 0, 0, []);
      Bmp.Transparent := True;
      Bmp.TransparentMode := tmAuto;
      Info.ImageIndex := ComponentImages.AddMasked(Bmp, Bmp.TransparentColor);
      Bmp1.Canvas.StretchDraw(Rect(0, 0, Bmp1.Width, Bmp1.Height), Bmp);
      ComponentImagesSmall.AddMasked(Bmp1, Bmp1.TransparentColor);
    finally
      Bmp.Free;
      Bmp1.Free;
    end;
  end;
  Result := Info.ImageIndex;
end;

procedure TFloatingPaletteForm.UpdateList;
var
  Item: TListItem;
  I: Integer;
begin
  Item := TabList.Selected;
  if Assigned(Item) and pnlList.Visible then
  begin
    Comps.Items.BeginUpdate;
    try
      FComps.Clear;
      for I := 0 to FCompInfoList.Count - 1 do
        if FCompInfoList[I].TabIndex = Integer(Item.Data) then
          FComps.AddObject(ClassNameNoT(FCompInfoList[I].ToolName), FCompInfoList[I]);

      Comps.Items.Count := FComps.Count;
    finally
      Comps.Items.EndUpdate;
    end;
  end
  else
    Comps.Items.Count := 0;
end;

procedure TFloatingPaletteForm.TreeChange(Sender: TObject; Node: TTreeNode);
begin
  if not FLoading then
  begin
    UpdateStatusBar;
    if Assigned(Node) then
      if not Assigned(Node.Data) then
      begin
        FPaletteTab.TabIndex := FPaletteTab.Tabs.IndexOf(Node.Text);
        FPaletteTab.OnChange(FPaletteTab);
        SelectTool(-1);
      end
      else
        SelectTool(TComponentInfo(Node.Data).TabIndex, TComponentInfo(Node.Data).ToolIndex)
    else
      SelectTool(-1);
  end;
end;

procedure TFloatingPaletteForm.actFloatingPaletteExecute(Sender: TObject);
var
  Ctl: TWinControl;
begin
  if Assigned(FloatingPaletteForm.HostDockSite) then
  begin
    Ctl := FloatingPaletteForm.HostDockSite;
    while Assigned(Ctl.Parent) do Ctl := Ctl.Parent;
  end
  else
    Ctl := FloatingPaletteForm;
  Ctl.Show;
  Ctl.BringToFront; 
end;

procedure TFloatingPaletteForm.actRefreshExecute(Sender: TObject);
begin
  LoadComponents;
end;

procedure TFloatingPaletteForm.actShowListExecute(Sender: TObject);
begin
  if pnlList.Visible then Exit;
  pnlList.Visible := True;
  pnlTree.Visible := False;
  ArrangeControls;
  if actUseComponentImages.Checked then actUseComponentImages.Execute;
  Tree.FullCollapse;
  SelectTool(-1);
  UpdateList;
  UpdateStatusBar;
end;

procedure TFloatingPaletteForm.actShowTreeExecute(Sender: TObject);
begin
  if not pnlList.Visible then Exit;
  pnlList.Visible := False;
  pnlTree.Visible := True;
  ArrangeControls;
  if not actUseComponentImages.Checked then actUseComponentImages.Execute;
  SelectTool(-1);
  UpdateStatusBar;
end;

procedure TFloatingPaletteForm.actShowListUpdate(Sender: TObject);
begin
  actShowList.Checked := pnlList.Visible;
end;

procedure TFloatingPaletteForm.actShowTreeUpdate(Sender: TObject);
begin
  actShowTree.Checked := not pnlList.Visible;
end;

procedure TFloatingPaletteForm.actConfigurePaletteExecute(Sender: TObject);
begin
  if TAction(Application.MainForm.FindComponent('ComponentPaletteCommand')).Execute then
    LoadComponents;
end;

procedure TFloatingPaletteForm.actSortedTabNamesExecute(Sender: TObject);
begin
  actSortedTabNames.Checked := not actSortedTabNames.Checked;
  if actSortedTabNames.Checked then
  begin
    Tree.Items.AlphaSort(False);
    TabList.AlphaSort;
  end
  else
    RefreshUI;
end;

procedure TFloatingPaletteForm.actSortComponentsExecute(Sender: TObject);
var
  Node: TTreeNode;
begin
  actSortComponents.Checked := not actSortComponents.Checked;
  FComps.Sorted := actSortComponents.Checked;
  if actSortComponents.Checked then
  begin
    Node := Tree.Items.GetFirstNode;
    while Assigned(Node) do
    begin
      Node.AlphaSort(False);
      Node := Node.getNextSibling;
    end;
    Comps.Invalidate;
  end
  else RefreshUI;
end;

function GetActiveFormEditor: IOTAFormEditor;
var
  Module: IOTAModule;
  Editor: IOTAEditor;
  I: Integer;
begin
  Result := nil;
  Module := (BorlandIDEServices as IOTAModuleServices).CurrentModule;
  if Assigned(Module) then
    for I := 0 to Module.ModuleFileCount - 1 do
    begin
      Editor := Module.ModuleFileEditors[I];
      if Supports(Editor, IOTAFormEditor, Result) then
        Exit;
    end;
end;

procedure TFloatingPaletteForm.actCreateComponentExecute(Sender: TObject);
var
  Editor: IOTAFormEditor;
  Info: TComponentInfo;
begin
  Info := GetActiveComponent;
  if not Assigned(Info) then Exit;
  Editor := GetActiveFormEditor;
  if Assigned(Editor) then
  begin
    Editor.CreateComponent(Editor.GetSelComponent(0), Info.ToolName, 0, 0, 0, 0);
    if actRollUpOnCreation.Checked then RollUp;
  end;
end;

procedure TFloatingPaletteForm.actCreateComponentUpdate(Sender: TObject);
var
  Editor: IOTAFormEditor;
  Info: TComponentInfo;
begin
  Info := GetActiveComponent;
  if Assigned(Info) then Editor := GetActiveFormEditor;
  actCreateComponent.Visible := Assigned(Info) and Assigned(Editor);
end;

procedure TFloatingPaletteForm.TreeGetImageIndex(Sender: TObject; Node: TTreeNode);
var
  Info: TComponentInfo;
begin
  if actUseComponentImages.Checked then
  begin
    if not Assigned(Node.Data) then
    begin
      Node.ImageIndex := 0;
      Node.SelectedIndex := 0;
    end
    else
    begin
      Node.ImageIndex := GetCompIndex(TComponentInfo(Node.Data));
      Node.SelectedIndex := Node.ImageIndex;
    end;
  end
  else
    if not Assigned(Node.Data) then
    begin
      Node.ImageIndex := 0;
      Node.SelectedIndex := 1;
    end
    else
    begin
      Info := TComponentInfo(Node.Data);
      if not Assigned(Info.ComponentClass) then
        Node.ImageIndex := -1
      else if Info.ComponentClass.InheritsFrom(TWinControl) then
        Node.ImageIndex := 4
      else if Info.ComponentClass.InheritsFrom(TControl) then
        Node.ImageIndex := 3
      else
        Node.ImageIndex := 2;
      Node.SelectedIndex := Node.ImageIndex;
    end;
end;

procedure TFloatingPaletteForm.actUseComponentImagesExecute(Sender: TObject);
begin
  actUseComponentImages.Checked := not actUseComponentImages.Checked;
  if actUseComponentImages.Checked then
    Tree.Images := ComponentImages
  else
    Tree.Images := TreeImages;
  Tree.Indent := 0;
end;

procedure TFloatingPaletteForm.TreeEnter(Sender: TObject);
begin
  if Assigned(Tree.Selected) and Assigned(Tree.Selected.Data) then
  with TComponentInfo(Tree.Selected.Data) do
    SelectTool(TabIndex, ToolIndex);
  UpdateStatusBar;
end;

procedure TFloatingPaletteForm.ArrangeControls;
begin
  if actVerticalArrangement.Checked then
  begin
    Splitter.Align := alTop;
    if pnlList.Visible then
    begin
      TabList.Align := alTop;
      TabList.Height := TabList.Parent.ClientHeight div 2;
      Splitter.Align := alTop;
      if Splitter.Visible then Splitter.Top := TabList.Top + TabList.Height + 1;
    end;
  end
  else
  begin
    Splitter.Align := alLeft;
    if pnlList.Visible then
    begin
      TabList.Align := alLeft;
      TabList.Width := TabList.Parent.ClientWidth div 2;
      if Splitter.Visible then Splitter.Left := Comps.Left - 1;
    end;
  end;
end;

procedure TFloatingPaletteForm.actVerticalArrangementExecute(Sender: TObject);
begin
  actVerticalArrangement.Checked := not actVerticalArrangement.Checked;
  ArrangeControls;
end;

procedure TFloatingPaletteForm.TreeMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  Exit; // BUG: Tree starts drag immediately
  if (ssLeft in Shift) and Assigned(Tree.Selected) and (Tree.Selected.Level = 1) then
    Tree.BeginDrag(False, 10);
end;

procedure TFloatingPaletteForm.RollUp;
begin
  if (FSaveHeight = 0) and not Assigned(Parent) then
  begin
    FSaveHeight := Height;
    ClientHeight := ToolBar1.Height;
    FMaxHeight := Height;
    Panel.Visible := False;
    AutoScroll := False;
    Dockable := False;
    actRollUp.ImageIndex := 13;
    actRollUp.Caption := sRollDown;
    actShowList.Visible := False;
    actShowTree.Visible := False;
    actSortedTabNames.Visible := False;
    actSortComponents.Visible := False;
    ToolButton4.Visible := False;
    actRefresh.Visible := False;
  end;
end;

procedure TFloatingPaletteForm.RollDown;
begin
  if FSaveHeight <> 0 then
  begin
    Panel.Visible := True;
    Height := FSaveHeight;
    BorderStyle := bsSizeToolWin;
    FSaveHeight := 0;
    FMaxHeight := 0;
    AutoScroll := True;
    actRollUp.ImageIndex := 14;
    actRollUp.Caption := sRollUp;
    actShowList.Visible := True;
    actShowTree.Visible := True;
    actSortedTabNames.Visible := True;
    actSortComponents.Visible := True;
    ToolButton4.Visible := True;
    actRefresh.Visible := True;
  end;
end;

function TFloatingPaletteForm.IsRolledDown: Boolean;
begin
  Result := Panel.Visible;
end;

procedure TFloatingPaletteForm.FormConstrainedResize(Sender: TObject; var MinWidth,
  MinHeight, MaxWidth, MaxHeight: Integer);
begin
  if not FLoadingState and not IsRolledDown then
  begin
    MinHeight := FMaxHeight;
    MaxHeight := FMaxHeight;
  end;
end;

procedure TFloatingPaletteForm.actRollUpExecute(Sender: TObject);
begin
  if IsRolledDown then RollUp else RollDown;
end;

procedure TFloatingPaletteForm.actRollUpHint(var HintStr: String;
  var CanShow: Boolean);
begin
  if IsRolledDown then HintStr := 'Roll up' else HintStr := 'Roll down';
end;

procedure TFloatingPaletteForm.actAutoRollupExecute(Sender: TObject);
begin
  if actAutoRollup.Checked then Dockable := False;
end;

procedure TFloatingPaletteForm.actSelectorExecute(Sender: TObject);
begin
  SelectTool(-1);
  if Assigned(Tree.Selected) and Assigned(Tree.Selected.Data) then
    Tree.Selected := nil;
  Comps.Selected := nil;
  tbtnSelector.Down := actSelector.Checked;
end;

procedure TFloatingPaletteForm.actSelectorUpdate(Sender: TObject);
begin
  actSelector.Checked := GetStrProp(FPalette, 'SelectedToolName') = ''
end;

procedure TFloatingPaletteForm.FormActivate(Sender: TObject);
begin
  if actAutoRollup.Checked then RollDown;
end;

procedure TFloatingPaletteForm.FormDeactivate(Sender: TObject);
begin
  if actAutoRollup.Checked then RollUp;
end;

procedure TFloatingPaletteForm.LoadSettings;
var
  S: string;
begin
  try
    with IDEIniFile do
    begin
      if ReadBool(Self.ClassName, 'VerticalArrangement', False) then actVerticalArrangement.Execute;
      actAutoRollup.Checked := ReadBool(Self.ClassName, 'AutoRollUp', False);
      actRollUpOnCreation.Checked := ReadBool(Self.ClassName, 'RollUpOnCreation', False);
      if ReadBool(Self.ClassName, 'List', False) then actShowList.Execute else actShowTree.Execute;
      pnlSearch.Visible := ReadBool(Self.ClassName, 'Search', False);
      Comps.ViewStyle := TViewStyle(ReadInteger(Self.ClassName, 'ListViewStyle', 0));
      S := ReadString(Self.ClassName, 'DisabledTabs', '');
      if S <> FDisabledTabs.CommaText then
      begin
        FDisabledTabs.CommaText := S;
        RefreshUI;
      end;
    end;
  except
  end;
end;

procedure TFloatingPaletteForm.SaveSettings;
begin
  with IDEIniFile do
  begin
    WriteBool(Self.ClassName, 'VerticalArrangement', actVerticalArrangement.Checked);
    WriteBool(Self.ClassName, 'AutoRollUp', actAutoRollup.Checked);
    WriteBool(Self.ClassName, 'RollUpOnCreation', actRollUpOnCreation.Checked);
    WriteBool(Self.ClassName, 'List', actShowList.Checked);
    WriteBool(Self.ClassName, 'Search', pnlSearch.Visible);
    WriteInteger(Self.ClassName, 'ListViewStyle', Ord(Comps.ViewStyle));
    WriteString(Self.ClassName, 'DisabledTabs', FDisabledTabs.CommaText);
  end;
end;

procedure TFloatingPaletteForm.actVerticalArrangementUpdate(Sender: TObject);
begin
  actVerticalArrangement.Visible := actShowList.Checked;
end;

procedure TFloatingPaletteForm.DoMainFormShown;
begin
  LoadComponents;
end;

function TFloatingPaletteForm.GetTreeState: string;
var
  Node: TTreeNode;
  S: string;
begin
  with TStringList.Create do
  try
    Delimiter := ';';
    if Assigned(Tree.Selected) and (Tree.Selected.Level = 0) then
      Values['Selected'] := Tree.Selected.Text;
    if Assigned(Tree.TopItem) then
      Values['TopItem'] := Tree.TopItem.Text;
    S := '';
    Node := Tree.Items.GetFirstNode;
    while Assigned(Node) do
    begin
      if Node.Expanded then S := S + Node.Text + ',';
      Node := Node.getNextSibling;
    end;
    Values['Expanded'] := S;
    Result := DelimitedText;
  finally
    Free;
  end;
end;

procedure TFloatingPaletteForm.SetTreeState(const Value: string);
var
  Node, Child: TTreeNode;
  SelectedText, TopItemText: string;
  Expanded: TStringList;
begin
  Tree.Items.BeginUpdate;
  try
    Tree.FullCollapse;
    with TStringList.Create do
    try
      Delimiter := ';';
      DelimitedText := Value;
      SelectedText := Values['Selected'];
      TopItemText := Values['TopItem'];

      Expanded := TStringList.Create;
      try
        Expanded.Sorted := True;
        Expanded.Delimiter := ',';
        Expanded.DelimitedText := Values['Expanded'];


        Node := Tree.Items.GetFirstNode;
        while Assigned(Node) do
        begin
          if SelectedText = Node.Text then Node.Selected := True;
          if TopItemText = Node.Text then Node.TreeView.TopItem  := Node;
          if Expanded.IndexOf(Node.Text) >= 0 then Node.Expand(False);
          Child := Node.getFirstChild;
          while Assigned(Child) do
          begin
            if TopItemText = Child.Text then Child.TreeView.TopItem  := Child;
            Child := Child.getNextSibling;
          end;
          Node := Node.getNextSibling;
        end;
      finally
        Expanded.Free;
      end;
    finally
      Free;
    end;
  finally
    Tree.Items.EndUpdate;
  end;
end;

procedure TFloatingPaletteForm.AMLoadComponents(var M: TMessage);
begin
  LoadComponents;
end;

procedure TFloatingPaletteForm.WMNCHitTest(var M: TWMNCHitTest);
begin
  inherited;
  if not IsRolledDown then
    // Prevent vertical sizing
    case M.Result of
      HTTOP, HTBOTTOM:
        M.Result := HTCAPTION;
      HTTOPLEFT, HTBOTTOMLEFT:
        M.Result := HTLEFT;
      HTTOPRIGHT, HTBOTTOMRIGHT:
        M.Result := HTRIGHT;
    end;
end;

procedure TFloatingPaletteForm.WMNCLButtonDblClick(var M: TWMNCMButtonDblClk);
begin
  inherited;
  if M.HitTest = HTCAPTION then
    if IsRolledDown then RollUp else RollDown;
end;

procedure TFloatingPaletteForm.actCustomizeExecute(Sender: TObject);
begin
  TVisibleTabsDialog.Run;
end;

procedure TFloatingPaletteForm.actStatusbarVisibleExecute(Sender: TObject);
begin
  pnlStatusBar.Visible := not pnlStatusBar.Visible;
end;

procedure TFloatingPaletteForm.actStatusbarVisibleUpdate(Sender: TObject);
begin
  actStatusbarVisible.Checked := pnlStatusBar.Visible;
end;

procedure TFloatingPaletteForm.ListWndProc(var Message: TMessage);

  procedure DoDefault;
  begin
    if Assigned(FOldListWndProc) then FOldListWndProc(Message);
  end;

begin
  case Message.Msg of
    WM_CREATE:
    begin
      DoDefault;
      ListView_SetIconSpacing(Comps.Handle, 38, 38);
    end;
  else
    DoDefault;
  end;
end;

procedure TFloatingPaletteForm.Dock(NewDockSite: TWinControl; ARect: TRect);
begin
  if (NewDockSite <> nil) and (NewDockSite <> NullDockSite) then
    actAutoRollup.Checked := False;
  inherited;
  actRollUp.Visible := not Assigned(HostDockSite) or (HostDockSite = Self);
end;

procedure TFloatingPaletteForm.TreeAdvancedCustomDrawItem(Sender: TCustomTreeView;
  Node: TTreeNode; State: TCustomDrawState; Stage: TCustomDrawStage;
  var PaintImages, DefaultDraw: Boolean);
begin
  inherited;
  if Stage = cdPrePaint then
    if Node.Selected then
    begin
      // Selection bk color will be clHighlight 
      Tree.Canvas.Font.Style := Tree.Canvas.Font.Style + [fsBold];
      Tree.Canvas.Font.Style := Tree.Canvas.Font.Style - [fsBold];
    end;
end;

procedure TFloatingPaletteForm.TabListSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
  inherited;
  UpdateList;
  UpdateStatusBar;
end;

procedure TFloatingPaletteForm.TabListEnter(Sender: TObject);
begin
  inherited;
  SelectTool(-1);
  UpdateStatusBar;
end;

procedure TFloatingPaletteForm.SplitterPaint(Sender: TObject);
var
  R: TRect;
begin
  inherited;
  R := Splitter.ClientRect;
  DrawEdge(Splitter.Canvas.Handle, R, BDR_RAISEDINNER, BF_RECT or BF_ADJUST);
end;

procedure TFloatingPaletteForm.CompsData(Sender: TObject; Item: TListItem);
var
  Info: TComponentInfo;
begin
  inherited;
  Info := TComponentInfo(FComps.Objects[Item.Index]);
  if Comps.ViewStyle = vsIcon then
    Item.Caption := ''
  else
    Item.Caption := FComps[Item.Index];
  Item.ImageIndex := GetCompIndex(Info);
  Item.SubItems.Add(Info.UnitName);
  Item.SubItems.Add(Info.PackageName);
end;

procedure TFloatingPaletteForm.CompsAdvancedCustomDrawItem(
  Sender: TCustomListView; Item: TListItem; State: TCustomDrawState;
  Stage: TCustomDrawStage; var DefaultDraw: Boolean);
var
  Info: TComponentInfo;
  Rect: TRect;
begin
  if Assigned(Item) and (Comps.ViewStyle = vsIcon) and (Stage = cdPrePaint) then
  begin
    DefaultDraw := False;
    Rect := Item.DisplayRect(drSelectBounds);
    Comps.Canvas.Brush.Color := clBtnFace;
    if Item.Selected then
    begin
      DrawFrameControl(Comps.Canvas.Handle, Rect, DFC_BUTTON, DFCS_BUTTONPUSH or DFCS_PUSHED or DFCS_FLAT);
      Comps.Canvas.Brush.Color := clBtnHighlight;
      InflateRect(Rect, -1, -1);
      Comps.Canvas.FillRect(Rect);
    end
    else
    begin
      Comps.Canvas.FillRect(Rect);
      InflateRect(Rect, -1, -1);
    end;
    Comps.Canvas.FillRect(Rect);
    Info := TComponentInfo(FComps.Objects[Item.Index]);
    if Assigned(Info) then
      ComponentImages.Draw(Comps.Canvas, Rect.Left + ((Rect.Right - Rect.Left) - ComponentImages.Width) div 2,
                                         Rect.Top + ((Rect.Bottom - Rect.Top) - ComponentImages.Height) div 2,
                                         GetCompIndex(Info));
  end;
end;

procedure TFloatingPaletteForm.CompsSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
  inherited;
  UpdateStatusBar;
  if Assigned(Item) and Selected then
    with TComponentInfo(FComps.Objects[Item.Index]) do
      SelectTool(TabIndex, ToolIndex)
  else
    SelectTool(-1);
end;

procedure TFloatingPaletteForm.CompsEnter(Sender: TObject);
begin
  inherited;
  if Assigned(Comps.Selected) then
  with TComponentInfo(FComps.Objects[Comps.Selected.Index]) do
    SelectTool(TabIndex, ToolIndex);
  UpdateStatusBar;
end;

procedure TFloatingPaletteForm.CompsInfoTip(Sender: TObject;
  Item: TListItem; var InfoTip: String);
begin
  inherited;
  with TComponentInfo(FComps.Objects[Item.Index]) do
    InfoTip := Format('%s (%s)', [ClassNameNoT(ToolName), UnitName]);
end;

procedure TFloatingPaletteForm.Action1Execute(Sender: TObject);
begin
  inherited;
  Comps.ViewStyle := TViewStyle(TCustomAction(Sender).Tag);
  Comps.Arrange(arDefault);
end;

procedure TFloatingPaletteForm.Action1Update(Sender: TObject);
begin
  inherited;
  with TCustomAction(Sender) do
    Checked := Comps.ViewStyle = TViewStyle(Tag);
end;

procedure TFloatingPaletteForm.actRollUpOnCreationExecute(Sender: TObject);
begin
  inherited;
  // Just enable the action.
end;

procedure TFloatingPaletteForm.btnGoClick(Sender: TObject);
var
  I, L, J: Integer;
  Item: TListItem;
  Node: TTreeNode;
  TabName, Target, ToolName: string;
begin
  inherited;
  with FCompInfoList do
  begin
    Target := cmbSearch.Text;
    L := Length(Target);
    for I := 0 to Count - 1 do
    begin
      ToolName := ClassNameNoT(Items[I].ToolName);
      if SameText(Target, Copy(ToolName, 1, L)) then
      begin
        TabName := FTabs[Items[I].TabIndex];
        if pnlList.Visible then
        begin
          Item := TabList.FindCaption(0, TabName, False, True, False);
          if Assigned(Item) then Item.Selected := True else Exit;
          J := FComps.IndexOf(ToolName);
          if J >= 0 then Comps.Selected := Comps.Items[J];
        end
        else
        begin
          Node := Tree.Items.GetFirstNode;
          while Assigned(Node) do
          begin
            if Node.Text = TabName then
              Break;
            Node := Node.getNextSibling;
          end;
          if not Assigned(Node) then Exit;
          Node := Node.getFirstChild;
          while Assigned(Node) do
          begin
            if Node.Text = ToolName then
            begin
              Node.Selected := True;
              Exit;
            end;
            Node := Node.getNextSibling;
          end;
        end;
        Break;
      end;
    end;
  end;
end;

procedure TFloatingPaletteForm.cmbSearchKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  inherited;
  if Key = VK_RETURN then
  begin
    Key := 0;
    btnGo.Click;
  end;
end;

procedure TFloatingPaletteForm.actSearchUpdate(Sender: TObject);
begin
  inherited;
  actSearch.Checked := pnlSearch.Visible;
end;

procedure TFloatingPaletteForm.actSearchExecute(Sender: TObject);
begin
  inherited;
  pnlSearch.Visible := not pnlSearch.Visible;
end;

procedure TFloatingPaletteForm.cmbSearchDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  inherited;
  cmbSearch.Canvas.FillRect(Rect);
end;

initialization

  RegisterDesktopFormClass(TFloatingPaletteForm, sPaletteSection, sInstanceName);
  RegisterFieldAddress(sInstanceName, @FloatingPaletteForm);

finalization

  UnregisterFieldAddress(@FloatingPaletteForm);
  FreeAndNil(FloatingPaletteForm);

end.
